// DOSCenter.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "DOSCenter.h"
#include "DOSCenterDlg.h"
#include "settingsandTools.h"
#include "fileStuff.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CDOSCenterApp

BEGIN_MESSAGE_MAP(CDOSCenterApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CDOSCenterApp construction

CDOSCenterApp::CDOSCenterApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CDOSCenterApp object

CDOSCenterApp theApp;

dizInfo	m_dizInfo;  // a global
// CDOSCenterApp initialization

BOOL CDOSCenterApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();
	//extern dizInfo	m_dizInfo;

	LPTSTR buff = g_appPath.GetBuffer(MAX_PATH);
	CString tmp;

	GetModuleFileName(NULL, buff, MAX_PATH);
	tmp = buff;
	g_appPath=(tmp.Left(tmp.ReverseFind('\\')));
	CWinApp::InitInstance();
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("DOSCenter"));

	CDOSCenterDlg dlg;
	m_detailedReport = false;
	m_reportPerfects = false;

	// Parse command line for standard shell commands, DDE, file open
	//CCommandLineInfo cmdInfo;
	//ParseCommandLine(cmdInfo);
	CString cmdLine=GetCommandLine();
//	AfxMessageBox(cmdLine, MB_ICONINFORMATION, 0);
	if (cmdLine.Find("-makedat") != -1)
	{
		CTime time = CTime::GetCurrentTime();
		CString d = time.Format( "%A, %B %d, %Y" );
		CString t = CTime::GetCurrentTime().Format("%H:%M");
		CString datenTime;
		datenTime = d+"@"+t;

		CCommandLineInfo cmdInfo;
		ParseCommandLine(cmdInfo);
		CSettingsandTools snt;
		CFileStuff fileStuff;
		CString inidata, header;
		FILE* inFile;
		FILE* outFile;
		if (cmdInfo.m_strFileName.Mid(1,1) !=':')
			inFile = fopen(g_appPath+"\\"+cmdInfo.m_strFileName,"r");
		else
			inFile = fopen(cmdInfo.m_strFileName,"r");
		if (inFile != NULL)
		{
				// parse the .ini file to get the goods
				fileStuff.loadFile(inFile, inidata);
				if (inidata.GetLength() ==0)
					return FALSE;
				inidata.Replace("__DATE__",datenTime);
				// get the target filename
				inidata.TrimLeft("<target>");
				theApp.m_DATPath = inidata.Left(inidata.Find("</target>"));
				theApp.m_DATPath.Trim();
				inidata.Trim();
				inidata.Replace(theApp.m_DATPath,"");
				inidata.Trim();
				inidata.TrimLeft("</target>");
				inidata.Trim();

				// get the header
				inidata.TrimLeft("<header>");
				header = inidata.Left(inidata.Find("</header>"));
				inidata.Replace(header,"");
				
				// write the header into the output file
				header.Replace("\n","\r\n");
				header.Trim();
				outFile = fopen(theApp.m_DATPath,"wb");
				if ( outFile != NULL )
				fwrite(header, sizeof( char ), header.GetLength(), outFile );
	
				if ( outFile != NULL )
				{
					fclose(outFile);
					outFile=NULL;
				}
				
				//inidata.Replace(header,"");
				inidata.Replace("</header>","");
				inidata.Replace("<paths>","");
				//inidata.Replace("</paths>","\r\n");
				// do this in a while loop so the .ini file can set multiple target folders
				inidata.Trim();
				while(inidata !="</paths>")
				{
					theApp.m_collectionPath = inidata.Left(inidata.Find("\n"));
					theApp.m_collectionPath.Trim();
					if (theApp.m_collectionPath.Left(1) !=";")
					{
						snt.m_recursive = true;
						snt.m_cmdLine = true;
						snt.makeDATFile();
					}
					inidata.Replace(theApp.m_collectionPath, "");
					inidata.Trim();
				}				
				fclose(inFile);
		}
		
		return FALSE;

	}


	//m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
// input: filenameCrcKey
// output: modified key
// example: in=gwbasic.exe_8675309
//         out=gwbasic.exe_8675309?1
// using ? as a key designator as it will never appear in a filename
void CDOSCenterApp::makeNewKey(CString &ROMFilenameKey)
{
	CString txt;
	CString adder;
	int Keyadder=0;
	txt = ROMFilenameKey;
	if (txt.Find('?') != -1)
	{
		adder = txt.Right(txt.GetLength()-txt.ReverseFind('?'));
		txt.TrimRight(adder);
		adder.Remove('?');
		sscanf(adder,"%d",&Keyadder);
		
	}
	Keyadder++;
	adder.Format("?%d",Keyadder);
	ROMFilenameKey=txt+adder;
}