// DOSCenter.h : main header file for the PROJECT_NAME application
//

#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "afxcmn.h"
#include "resource.h"		// main symbols
#include <map>
#include "afxcmn.h"
#include "Unzipper.h"
#include "zipper.h"
#include "easysize.h"
#include "SADirRead.h"
#include "SortListCtrl.h"
#include <afxtempl.h>
#include "splittercontrol.h"
#include "SettingsandTools.h"
#include "DOSCenter.h"
//#include "dizInfo.h"


// how about an enum here eh?
// zip names list (left side window)
#define COLORCOL 0
#define FILENAMECOL 1
#define NEWFILENAMECOL 2
#define SCORECOL 3
#define MATCHCOL 4
#define MISSCOL 5
#define UNKCOL 6


// these are inverted values as calculated here: http://www.drpeterjones.com/colorcalc/
#define COLOR_HIDE "0xffffffff"
#define COLOR_RED "0x0000ff"
#define COLOR_RED_IGNORED "0x9999ff"
#define COLOR_GREEN "0x009900"
//#define COLOR_GREEN2 "0x00ccff"
#define COLOR_BLACK "0x000000"
#define COLOR_YELLOW "0x4d7cc9" 
#define COLOR_BLUE   "0xA0522D"
#define COLOR_LGREEN "0x009999"
#define COLOR_PURPLE "0xff00ff"
#define COLOR_BROWN	"0x006699"
#define COLOR_GRAY "0x999999"
#define COLOR_PBROWN "0x042690" // tzip color reddish brown
#define COLOR_TZIPPED 0x770000
#define ALTERNATE_CRC 0x80000000		// flag that this ROM has multiple CRCs


#define TZIPPED 0x40000000

#define MAX_CRC_COLLISIONS	100

// CDOSCenterApp:
// See DOSCenter.cpp for the implementation of this class
//


typedef struct _ROMENTRY	// each file (ROM) inside the zip or a .dat entry
{
	CString name;			// filename
	unsigned int size;		// size 
	unsigned int crc;		// this rom's CRC 
	unsigned int date;		// upper 16=date, lower 16=time
	unsigned int status;	// bitmask info, see below
//	bool alternate;			// if set then
//	unsigned int crc2;		// this is valid (for pklited or lzexed file)
} datEntry;

// status bitfields
#define DATENTRY_STATUS_IGNORE 1	// this ROM is in the user's ignore list


typedef struct _ZIPMERGE
{
	CString filename;		// top level filename
	int		fileCount;		// # of files inside it
	map<CString, _ROMENTRY> mymap;	// storage, make the filename the key
	map<CString, _ROMENTRY>::const_iterator it;	// an iterator
} ZIPMERGE;


typedef struct _BESTHITS
{ // hey dumbass.  if you change any of these, make sure you change sortResults() too!
	CString filename;	// filename of ZIP file
	float	score;		//  overall score
	float   zipScore;	// % of matches in this zip
	unsigned int		perfects;	// # of matching filename+CRC's found
	unsigned int		zipCount;	// # of files inside this zip
	unsigned int		crcMatch;	// # of CRC matches but filename mismatches
	unsigned int		dupes;		// # of CRC matches that are also in other .dat entries (not useful, but not damaging to the score)
	unsigned int		datCount;	// # of files from the dat for this top ten hit
	unsigned int		zipPos;		// CList position where the data was found
} BESTHITS;

typedef struct _IGNOREFILE
{
	CString filename;
	CString ext;
	unsigned int crc;
} IGNOREFILE;

typedef struct _FILESTRUC	// each .dat file entry, contains all the files inside the zip
{
	CString filename;		// top level filename from .dat
	int		fileCount;		// # of files inside entry
	map<unsigned int, _ROMENTRY> mymap;	// storage for crc, name of file and size
	map<unsigned int, _ROMENTRY>::const_iterator it;	// an iterator
	int statusFlags;
	CString realFilename;	// actual zip file that is the closest match to this .dat entry
	int collisionPtr;
} FILESTRUC;




//typedef struct _CRCCOLLISION
//{
//	CString ZIPFilename;		// zip filename of the 1st file using this CRC.
//	CString romFilename;		// file name of the 2nd ROM using that CRC
//	unsigned int crc;			// the CRC itself.
//} CRCCOLLISION;


//typedef struct _DATFILE		// everything from the dat file goes into this cmap
//{
//	CString			filename_CRC;
//	bool			collision;
//	CString			date;
//	unsigned int	size;
//	unsigned int	zipNamePtr;
//} DATFILE;

// rom data structure (each file inside a zip gets filled in here)
struct ROMdata
{
	CString fileName;	// filename.ext
	unsigned int size;	// file's size in bytes
	unsigned int crc;	// file's CRC as pulled from .dat file/zip header
	unsigned int date;	// file's date
	bool collision;		// collision detected in CMAP
	unsigned int ptr2zipFileArray; // pointer to this rom's main .zip filename in the dat file
	int status;			// misc flags-n-stuff
	CString newFileName; // when a filename inside a zip is wrong, and the dat thinks it should be this
};


// Info about each ZIP file as its pulled in from the .dat file.  We also keep some data here during scanning
struct ZIPdata
{
	CString filename;	// zip filename 
	int fileCount;		// number of files declared in this zip(dat entry)
	int status;			// status (perfect match, missing some stuff, extra, whatever) - filled in after a file scan.
	map<unsigned int, _ROMENTRY> ROMsMap;	// storage for each rom's crc, name of file and size
	map<unsigned int, _ROMENTRY>::const_iterator it;	// an iterator to be able to scan through this zip's list of roms

};
class CDOSCenterApp : public CWinApp
{
public:

	CDOSCenterApp();
//	CDOSCenterDlg m_pMain;
// Overrides
	public:
	virtual BOOL InitInstance();
	CString m_DATPath;
	//FILESTRUC* m_fileData;
	unsigned int m_datfileCount;	// for info only, # of zips inthe loaded .dat file
	unsigned int m_datROMCount;		// " " " # of roms in the zips in the dat loaded
	bool m_DATfileLoaded;
	bool m_autoLoadDat;
	bool m_reloadIgnore;
	bool m_ignoreOn;
	unsigned int m_minFilesize;
	CString m_currentlyTaggedZipFile;
	CSortListCtrl m_zipDetailsList;
	CSortListCtrl m_leftSideList;
	CSortListCtrl m_leftSideDATList;

	CString m_collectionPath;		// folder where main collection exists (ie, where .dat file is built off of)
	CString m_tmpWorkingFolder;
	CString m_dosboxPath;
	CString g_appPath;
	CString m_defaultMovePath;
	_IGNOREFILE m_ignoreThese[400];


	CString m_datName;
	CString m_datDescription;
	CString m_datHomepage;
	CString m_datdate;
	CString m_datVersion;
	CString m_datComment;
	CString m_datAuthor;


	int m_ignoreTheseCount;
	CString m_ignoreFileData;
	int m_ignoreStartPos;
	int m_minScoreForAutoRename;
	bool	m_detailedReport;
	bool	m_ScanCRCFilename;
	bool	m_reportPerfects;
	bool	m_makeFQFScript;
	bool m_datParsed;
	CString m_mySitesDat;
	CString m_fxpDlPath;
	
	ULONGLONG m_selectedYears;
	bool m_zipIsFoldered;

	void makeNewKey(CString &ROMFilenameKey);
	
// here we store each ROM from the .dat file.  entries are stored as a key of romname_crc to make them unique
// if there are duplicates (like gwbasic.exe_987341 would show up multiple times across zip files), then each key is appended with ?1, ?2, etc to make them unique
	//    key      whatever  thing stored  whatever
	CMap< CString, LPCSTR,   ROMdata,      ROMdata& > m_ROMDATEntryName;
	CMap< CString, LPCSTR,   ROMdata,      ROMdata& > m_ROMDATEntryCRC;
	//	CMap< CString, LPCSTR,   ROMdata,      ROMdata& >::iterator;
	// key is filename_crc and is always unique
	// ROMdata is file attributes and a pointer into the zipMap (below) where that file belongs


	// list of zipfiles loaded in during the .dat parsing process
	// a pointer to the filename in this list is stored in each ROMdata entry.
//	CMap<CString, LPCSTR, ZIPdata, ZIPdata&> m_datZipFiles;




	// list of zipfiles loaded in during the .dat parsing process
	// this guy has a map inside the structure inside the map that we're storing!
	// data stored here is zip filename and number of roms contained therein.
	std::map <unsigned int, ZIPdata > m_datZipList;
	std::map <unsigned int, ZIPdata >::iterator m_datZipListit;


//	std::map <string, romList> grade_list;


	std::map <unsigned int, ROMdata > m_tmpzipList; // temporary storage for pulling things out of the cmap when looking inside a zip
	
	DECLARE_MESSAGE_MAP()
	
};

extern CDOSCenterApp theApp;