// DOSCenterDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "Unzipper.h"
#include "zipper.h"
#include "easysize.h"
#include "SADirRead.h"
#include "SortListCtrl.h"
#include "splittercontrol.h"
#include "SettingsandTools.h"
#include "DOSCenter.h"
#include "progressDlg.h"
#include "dizInfo.h"


#define TOPARRAYSIZE 26	// it would be so much better to make this a map instead.
#define MAX_DATFILE 20000	// maximum number of .dat file entries


// for generating a full report
#define STATUS_PERFECT 100
#define STATUS_RENAME_ZIP_ONLY 99
#define STATUS_RENAME_ROMS 85
#define STATUS_CRC_COLLISION 45
#define STATUS_EXTRAFILES 101
#define STATUS_MISSINGFILES 72


// ROM details
#define STATUS_ROM_FOUND 1
#define STATUS_ROM_ELSEWHERE 2
#define STATUS_ROM_IGNORED 3
#define STATUS_ROM_NAMEWEIRD 4
#define STATUS_ROM_CRC_MATCH 8
#define STATUS_ROM_FILENAME_MATCH 16
#define STATUS_ROM_TIMESTAMP_MATCH 32
#define STATUS_ROM_PERFECT_MATCH (STATUS_ROM_CRC_MATCH+STATUS_ROM_FILENAME_MATCH+STATUS_ROM_TIMESTAMP_MATCH)

// CDOSCenterDlg dialog
class CDOSCenterDlg : public CDialog
{
// Construction
public:
	CDOSCenterDlg(CWnd* pParent = NULL);	// standard constructor
	DECLARE_EASYSIZE

// Dialog Data
	enum { IDD = IDD_DOSCENTER_DIALOG };

	SIZE	m_sizeView;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual void OnCancel( );
	CSplitterControl     m_wndSplitter1; 

// Implementation
protected:
	HICON m_hIcon;
	CUnzipper m_uz;
	CZipper m_zip;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
	afx_msg void OnSize(UINT nType, int cx, int cy); 
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	void DoResize1(int delta);
	unsigned int m_zipCount;
	CSADirRead m_zipDir;
	CSADirRead::SAFileVector::const_iterator m_zipFiles; // index thingyabob into file array
public:
	int m_zipCRCmatches;
	int m_zipNameMatches;
	int m_zipTimestampMatches;
	int m_exactMatches;
	int m_zipIgnored;
	int m_datIgnored;
	CString m_buriedZipFolder;
	
	//bool zipName2Vars(CString filename, bool silent);


	afx_msg void OnBnClickedZipfolderbrowsebtn();
	CString m_SourcePath;		// path of files we're scanning
	CString m_updatePackSourcePath;
	void updateZipList();
	void scanSelectedZips();
	void scanThisZip(int nIndex, CProgressDlg* progDlg);
	int getDatPtr(CString filename);

//	CSADirRead::SAFileVector::const_iterator m_ROMFiles; // index thingyabob into file array
	
//	CSADirRead m_ROMsDir;
	afx_msg void OnNMDblclkZipList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMDblclkZipFileList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickLeftSideList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickRightSideList(NMHDR *pNMHDR, LRESULT *pResult);
	
	
	afx_msg void OnBnClickedLoaddatfile();
	
	void add2database();
	void add2datFile();
	int scanAZipFile(CString sourceFile, int &matches, int &missing, int &unknown, int &flags);
	void sortTopTen();
	bool scanCRCs(unsigned int crc, CString romName);
	bool mergeZipFiles();
	bool skipafile(CString filename, CString ext, unsigned int crc, unsigned int fileSize);
	void add2Ignore();
	int deepScan(CString sourceFile);
	void checkDatvsZip(int zipPos, int m_nFileCount, bool cleanup);
	void moveSelectedFiles(CString tgtPath);
	void unzipAFile(CString zipFilename, CString destination);
//	unsigned int matchCRC(unsigned int crc, unsigned int mapPos=0);
	int m_topTenIdx;
	_BESTHITS m_topTen[TOPARRAYSIZE];
	void scanAllFiles();
	void hexViewFile();
	void compare2Files();
	BOOL DestroyWindow();
	void unNestZipFile();
	CString m_score;
	void populateIgnoreList();
	int addtoTop10(CString zipName);
	int m_scannedZipFileCount;
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedHidematches();
	afx_msg void OnBnClickedHidemissing();
	afx_msg void OnBnClickedHideunknown();
	afx_msg void OnLvnKeydownZipdetailslist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnKeydownLeftsidelist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMDblclkDatFileList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedSettingsbtn();
	CString extractExtension(CString &filename);
	CString extractFilenameWOPath(CString filename);
	CString findRootZipFolder(CString zipfilename);


	//void generateExtraFileReport(int i, CString &extraFiles);
	void deleteFileInZip();
	void renameFileInZip();
	void zip2NewFile();
	LRESULT  CDOSCenterDlg::OnDropFiles(WPARAM wParam,LPARAM lParam);
	void renameZipFileWithPopUpDialog();
	void doYearScan();
	void fixAZip();
	bool fixazip(CString zipName, int zipPosPtr);
	void populateDATFileDataView();
	void CopyToClipboard(const char* stringbuffer);
	bool extractFileFromUpdatePack(CString filename, CString crc);
	bool addAFileToAZip(CString targetZip, CString filename);
	bool unzipAndFixAROMFromAZip(CString sourceZipname, CString targetFilename, CString tmpFolder, unsigned int CRC, unsigned int timestamp);
	bool getROMFromUpdatePacks(CString targetFilename, CString tmpFolder, unsigned int CRC, unsigned int timestamp);
	bool makeafile_iddotdiz(CString filename, CString tmpFolder);

// column widths for left and right panels
// Color,0; Filename,150; New Filename,200; Score,50
// Color,0; name,80; type,40; size,70; date,70; crc,70
typedef struct _COLUMNWIDTHS	
{
	unsigned int Lcolor;
	unsigned int Lfilename;
	unsigned int Lnewfilename;
	unsigned int Lscore;
	unsigned int Lmatched;
	unsigned int Lmissing;
	unsigned int Lunknown;
	unsigned int Rcolor;
	unsigned int Rname;		
	unsigned int Rtype;
	unsigned int Rsize;
	unsigned int Rdate;
	unsigned int Rcrc;
	unsigned int LViewName;

	_COLUMNWIDTHS()		// set default values.  these are pulled from teh registry and overridden if they have been changed.
	{
		Lcolor = 0;
		Rcolor = 0;
		Lfilename = 150;
		Lnewfilename = 200;
		Lmatched = 30;
		Lmissing = 30;
		Lunknown = 30;
		Lscore = 40;
		Rname = 80;
		Rtype = 40;
		Rsize = 70;
		Rdate = 70;
		Rcrc = 70;
		LViewName = 150;
	};
} datEntry;

afx_msg void OnBnClickedApplyignore();
afx_msg void OnBnClickedHidealts();
afx_msg void OnBnClickedMissinglist();
afx_msg void OnBnClickedDatzipflip();
bool m_datview;


};
