#include "StdAfx.h"
#include ".\filestuff.h"

CFileStuff::CFileStuff(void)
{
}

CFileStuff::~CFileStuff(void)
{
}

BOOL CFileStuff::UserBrowseOpen(CString *pPath, LPCTSTR Filter, LPCTSTR DefaultExt)
{

	OPENFILENAME	ofn;

	LPTSTR lpPathBuff = pPath->GetBuffer(MAX_PATH);

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = Filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrDefExt = DefaultExt;
	ofn.lpstrFile = lpPathBuff;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrCustomFilter = NULL;
	ofn.lpstrTitle = m_windowTitle;  // window title
	ofn.Flags = OFN_HIDEREADONLY+OFN_EXPLORER;
	


	// display file open/save dialog
	BOOL result;
	result = GetOpenFileName(&ofn);

	pPath->ReleaseBuffer();

	return result;
}

BOOL CFileStuff::UserBrowseSave(CString *pPath, LPCTSTR Filter, LPCTSTR DefaultExt)
{

	OPENFILENAME	ofn;

	LPTSTR lpPathBuff = pPath->GetBuffer(MAX_PATH);

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = Filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrDefExt = DefaultExt;
	ofn.lpstrFile = lpPathBuff;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrCustomFilter = NULL;
	ofn.lpstrTitle = m_windowTitle;  // window title
	ofn.Flags = OFN_HIDEREADONLY+OFN_EXPLORER;
	
	// display file open/save dialog
	BOOL result;
	result = GetSaveFileName(&ofn);

	pPath->ReleaseBuffer();

	return result;
}

// part of user browse folder below
int CALLBACK BrowseCallbackProc(HWND hwnd,
    UINT uMsg,LPARAM lParam,LPARAM lpData)
{
	extern CString srcPathBrowse;

	// Look for BFFM_INITIALIZED so we know our dialog is available
	if(uMsg == BFFM_INITIALIZED)
    {

		SendMessage(hwnd, BFFM_SETSELECTION,
			TRUE, (LPARAM)(LPCTSTR)(srcPathBrowse)); 
    }
    return 0;
}
// this is a pass-thru between userBrowseFolder and the callback above.
CString srcPathBrowse = "c:\\";	// default to something safe.

BOOL CFileStuff::UserBrowseFolder(CString &folderpath, const char* szCaption, HWND hOwner)
{
	BOOL retVal = false;
	
	// if we've already got a file path, lets start the browse there.
	extern CString srcPathBrowse;
	if (folderpath.GetLength() > 0)
		srcPathBrowse = folderpath;

	// The BROWSEINFO struct tells the shell 
	// how it should display the dialog.
	BROWSEINFO bi;
	memset(&bi, 0, sizeof(bi));

	bi.ulFlags   = BIF_USENEWUI | BIF_VALIDATE;
	bi.hwndOwner = hOwner;
	bi.lpszTitle = szCaption;
	
	// Set the callback function
    bi.lpfn = BrowseCallbackProc;

	// must call this if using BIF_USENEWUI
	::OleInitialize(NULL);

	// Show the dialog and get the itemIDList for the selected folder.
	LPITEMIDLIST pIDL = ::SHBrowseForFolder(&bi);

	if(pIDL != NULL)
	{
		// Create a buffer to store the path, then get the path.
		char buffer[_MAX_PATH] = {'\0'};
		if(::SHGetPathFromIDList(pIDL, buffer) != 0)
		{
			// Set the string value.
			folderpath = buffer;
			retVal = true;
		}		

		// free the item id list
		CoTaskMemFree(pIDL);
	}

	::OleUninitialize();

	return retVal;
}

	

// returns false when EOF reached
bool CFileStuff::loadFile(FILE* pinputFile, CString &fileData)
{
	bool eof = false;	// reached end of file?
	char buffer[200];
	bool flag=false;
	fileData = "";
	CString tmp;

	while (1)
	{
	if (fgets(buffer,sizeof(buffer),pinputFile) != NULL)
			{	
				tmp=buffer;
				fileData +=tmp;
			}
	else
		{
			eof = true;	// flag EOF
			break;  // exit while loop on read error
		}
	}
	return !eof;
}

bool CFileStuff::getDATHeader(FILE* pinputFile, CString &header)
{
	#define bufSize 2048
	char buffer[bufSize];
	header="";
	CString tmp;
	while (1)
	{
		if (fgets(buffer,sizeof(buffer),pinputFile) != NULL)
		{
			tmp = buffer;
			if (tmp.Find("game (") == -1)
                header+=tmp;
			else
				break;
		}
		else // EOF reached.  WTF?
		{
			header="";
			break;
		}
	}
	header.Trim();
	if (header.GetLength() > 0)
		return true;
	return false;
}


// returns false when EOF reached
// returns file position of the start of the rom, -1 for end of file.
// if a file position is inputted, we seek to that starting point before starting to search for our keyword
int CFileStuff::getROMDesc(FILE* pinputFile, CString &romDesc, CString keyword, int filePos)
{
#define bufSize 2048

	//	bool eof = false;	// reached end of file?
	CString tmp;
	char buffer[bufSize];
	bool flag=false;
	romDesc = "";

	if (filePos != -1)
		fseek(pinputFile, filePos, SEEK_SET);

	while (1)
	{
	if (fgets(buffer,sizeof(buffer),pinputFile) != NULL)
			{	
				tmp=buffer;
				if (tmp.Find("game (") > -1 ) // first line of rom list located?
				{
					fgetpos (pinputFile,&m_filePos); // save file pos incase we need it for backing up
					m_filePos -=tmp.GetLength();
					flag = true;
				}	
				if (flag == true) romDesc +=tmp;  // append this line to buffer
				
				if ( (tmp == ")\n") && (flag==true) )	// found the end?  Maybe switch this to something that reflects different search criteria
					break;
			}
	else
		{
			m_filePos = -1; //eof = true;	// flag EOF
			break;  // exit while loop on read error
		}
	}

	return (int)m_filePos; //!eof;
}

BOOL CFileStuff::DeleteDirectory(const TCHAR* sPath) 
{
   HANDLE hFind;    // file handle
   WIN32_FIND_DATA FindFileData;
   CFileStatus fileStatus;

   TCHAR DirPath[MAX_PATH];
   TCHAR FileName[MAX_PATH];

   _tcscpy(DirPath,sPath);
   _tcscat(DirPath,"\\*");    // searching all files
   _tcscpy(FileName,sPath);
   _tcscat(FileName,"\\");

   // find the first file
   hFind = FindFirstFile(DirPath,&FindFileData);
   if(hFind == INVALID_HANDLE_VALUE) return FALSE;
   _tcscpy(DirPath,FileName);

   bool bSearch = true;
   while(bSearch) {    // until we find an entry
      if(FindNextFile(hFind,&FindFileData)) {
         if(IsDots(FindFileData.cFileName)) continue;
         _tcscat(FileName,FindFileData.cFileName);
         if((FindFileData.dwFileAttributes &
            FILE_ATTRIBUTE_DIRECTORY)) {

            // we have found a directory, recurse
            if(!DeleteDirectory(FileName)) {
                FindClose(hFind);
                return FALSE;    // directory couldn't be deleted
            }
            // remove the empty directory
            RemoveDirectory(FileName);
             _tcscpy(FileName,DirPath);
         }
         else {
            if(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_READONLY)
			{
               // change read-only file mode
             //     _chmod(FileName, _S_IWRITE);
				//read information
				CFile::GetStatus(FileName,fileStatus);
				fileStatus.m_attribute = 0;
				//save
				CFile::SetStatus(FileName,fileStatus);
			}             
				  if(!DeleteFile(FileName)) 
				  {    // delete the file
                    FindClose(hFind);
                    return FALSE;
               }
               _tcscpy(FileName,DirPath);
         }
      }
      else {
         // no more files there
         if(GetLastError() == ERROR_NO_MORE_FILES)
         bSearch = false;
         else {
            // some error occurred; close the handle and return FALSE
               FindClose(hFind);
               return FALSE;
         }

      }

   }
   FindClose(hFind);                  // close the file handle

   return RemoveDirectory(sPath);     // remove the empty directory
}

BOOL CFileStuff::IsDots(const TCHAR* str) 
{
   if(_tcscmp(str,".") && _tcscmp(str,"..")) return FALSE;
   return TRUE;
}

bool CFileStuff::setTimestamp(CString filepath, unsigned int timestamp)
{
//	FILETIME dateTime;
//	SYSTEMTIME sysTime;
	CFileStatus fileStatus;
	WORD dosDate;
	WORD dosTime;
	dosDate = (WORD)(timestamp >> 16);
	dosTime = (WORD)timestamp & 0xffff;	

	// does the date+time stamp need to be updated?
	//read information
	CFile::GetStatus(filepath, fileStatus);
	// convert 
	// if (datetime != tempZIPdata.ROMsMap[i].date);
	//change last access date
	CTime lastAccess = fileStatus.m_atime;
	//modify (new date/time : 10:10:10, 1989-12-12)
	//lastAccess = CTime(1989,12,12,10,10,10);
	lastAccess = CTime(dosDate, dosTime); 
	//m_mtime must always be changed
	fileStatus.m_mtime = lastAccess;
	//save
	CFile::SetStatus(filepath, fileStatus);
	return true;
}
bool CFileStuff::setTimestampFolder(CString filepath, unsigned int timestamp)
{
    FILETIME ft;
    SYSTEMTIME st;
    BOOL f;
	HANDLE hFile;

	WORD dosDate;
	WORD dosTime;
	dosDate = (WORD)(timestamp >> 16);
	dosTime = (WORD)timestamp & 0xffff;	

    hFile = CreateFile((LPCTSTR)filepath,      // name of the write
                       GENERIC_WRITE,          // open for writing
                       0,                      // do not share
                       NULL,                   // default security
                       OPEN_EXISTING,          // create new file only
                       FILE_FLAG_BACKUP_SEMANTICS, //FILE_ATTRIBUTE_NORMAL,  // normal file
                       NULL);                  // no attr. template

// Convert CTime to FILETIME
CTime time(dosDate, dosTime);
time.GetAsSystemTime(st);
::SystemTimeToFileTime(&st, &ft);

    f = SetFileTime(hFile,           // Sets last-write time of the file 
        (LPFILETIME) NULL,           // to the converted current system time 
        (LPFILETIME) NULL, 
        &ft);    
	CloseHandle(hFile);
    return f;
}