// SettingsandTools.cpp : implementation file
//

#include "stdafx.h"
#include "DOSCenter.h"
#include "SettingsandTools.h"
#include ".\settingsandtools.h"
#include "fileStuff.h"
#include "registry.h"
#include "progressDlg.h"
#include "DOSCenterDlg.h"
#include "DATFileInfoDlg.h"
#include "ScoringSetupDlg.h"
#include "HaveMissDlg.h"

// CSettingsandTools dialog

IMPLEMENT_DYNAMIC(CSettingsandTools, CDialog)
CSettingsandTools::CSettingsandTools(CWnd* pParent /*=NULL*/)
	: CDialog(CSettingsandTools::IDD, pParent)
{
}

CSettingsandTools::~CSettingsandTools()
{
}

void CSettingsandTools::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MINRENAMESCORE_EDIT, m_minScore4Rename);
}


BEGIN_MESSAGE_MAP(CSettingsandTools, CDialog)
	ON_BN_CLICKED(IDC_LOADDATFILE, OnBnClickedLoaddatfile)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_MAKEADAT, OnBnClickedMakeadat)
	ON_BN_CLICKED(IDC_SCRATCHPADBROWSE, OnBnClickedScratchpadbrowse)
	ON_BN_CLICKED(IDC_SETDOSCOLLECTIONPATHBTN, OnBnClickedSetdoscollectionpathbtn)
	ON_BN_CLICKED(IDC_SCORINGCFGBTN, OnBnClickedScoringcfgbtn)
	ON_BN_CLICKED(IDC_DOSBOXBROWSE, OnBnClickedDosboxbrowse)
	ON_BN_CLICKED(IDC_DATFILEINFO, OnBnClickedDatfileinfo)
//	ON_BN_CLICKED(IDC_CRCSCAN, OnBnClickedCrcscan)
//	ON_BN_CLICKED(IDC_CRCFILENAME, OnBnClickedCrcfilename)
ON_BN_CLICKED(IDC_MISSINGLIST, OnBnClickedMissinglist)
ON_BN_CLICKED(IDC_DETAILEDREPORTS, OnBnClickedDetailedreports)
ON_BN_CLICKED(IDC_PERFECTSTOO, OnBnClickedPerfectstoo)
ON_BN_CLICKED(IDC_FQFOUTPUT, OnBnClickedFqfoutput)
ON_BN_CLICKED(IDC_FQF_DL_PATH, OnBnClickedFqfDlPath)
ON_BN_CLICKED(IDC_HAVEMISSLISTCFG, OnBnClickedHavemisslistcfg)
END_MESSAGE_MAP()


BOOL CSettingsandTools::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_cmdLine = false;
	CString txt;
//	CDOSCenterDlg m_pMain;
	((CButton*)GetDlgItem(IDC_DATAUTOLOAD))->SetCheck(theApp.m_autoLoadDat);
	txt = theApp.m_tmpWorkingFolder.TrimRight("\\DOSCenter");
	((CButton*)GetDlgItem(IDC_SCRATCHPATHTXT))->SetWindowText(txt);
	((CButton*)GetDlgItem(IDC_DOSCOLLECTIONPATHTXT))->SetWindowText(theApp.m_collectionPath);
	((CButton*)GetDlgItem(IDC_DOBOXPATHTXT))->SetWindowText(theApp.m_dosboxPath);
	if (theApp.m_DATfileLoaded)
		((CButton*)GetDlgItem(IDC_DATFILENAMETXT))->SetWindowText(theApp.m_DATPath);
	else
	{
		((CButton*)GetDlgItem(IDC_DATFILENAMETXT))->SetWindowText("no .dat file loaded");
		((CButton*)GetDlgItem(IDC_DATFILEINFO))->EnableWindow(0);
	}
	txt.Format("%d", theApp.m_minScoreForAutoRename);
	m_minScore4Rename.SetWindowText(txt);

	((CButton*)GetDlgItem(IDC_DETAILEDREPORTS))->SetCheck(theApp.m_detailedReport);
	((CButton*)GetDlgItem(IDC_PERFECTSTOO))->SetCheck(theApp.m_reportPerfects);
	((CButton*)GetDlgItem(IDC_FQFOUTPUT))->SetCheck(theApp.m_makeFQFScript);
	OnBnClickedDetailedreports();
	OnBnClickedFqfoutput();
	((CButton*)GetDlgItem(IDC_FQFLOGIN))->SetWindowText(theApp.m_mySitesDat);

//	if (theApp.m_ScanCRCFilename)
//		((CButton*)GetDlgItem(IDC_CRCFILENAME))->SetCheck(1);
//	else
//		((CButton*)GetDlgItem(IDC_CRCSCAN))->SetCheck(1);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// CSettingsandTools message handlers

// browse and load in the .dat file
void CSettingsandTools::OnBnClickedLoaddatfile()
{
	CFileStuff fileStuff;
	//CDOSCenterDlg m_pMain;
	// open a "browse to folder" dialog
	CString arg;
	CString filename;
	
	LPCTSTR FileFilter = "dat files (*.dat)\0*.dat\0"; 
	LPCTSTR FileExt = "dat";
	fileStuff.m_windowTitle = "Gimme a dat file please...";

	if (fileStuff.UserBrowseOpen(&fileStuff.m_sFilePath, FileFilter, FileExt))
	{
		
		theApp.m_DATPath = fileStuff.m_sFilePath;
		CRegistry regMyReg( CREG_CREATE );  // create registry key if it doesn't exist.
		if ( regMyReg.Open("Software\\DOSCenter",HKEY_CURRENT_USER) ) 
			{
				// Now set the new values
				regMyReg["datFolders"] = theApp.m_DATPath; 
				regMyReg.Close();
			}

		// open the file and load 'er in.
		parseDATFile();
		((CButton*)GetDlgItem(IDC_DATFILEINFO))->EnableWindow(1);
		((CButton*)GetDlgItem(IDC_DATFILENAMETXT))->SetWindowText(theApp.m_DATPath);
	}

}

// open .dat file and pull in names and CRC values. 
// at the end of this routine, we have two globally available maps:
// one for the zipfile and one for the roms inside each zip
// for each rom,we have an index pointer back to the zip that contains said rom.
//TODO - think about a method of loading in binary data so that parsing would be faster.  if one I could get a cmap memory dump and just load that bitch in!
void CSettingsandTools::parseDATFile()
{
	FILE* inFile;
	CFileStuff fileStuff;
	CString romDesc;
	int pos, pos2, tpos;
	int eof=0;
	int romCount;
	CString name;
	CString scrc;
	CString ssize;
	CString ext, tmpfilename;
	CString txt;
	CString datetime;
	unsigned int date;
	CString zipFilename;
	CDOSCenterDlg DC;
//	bool alternate;
	CString header;
	int status;
//	int alts;
//	unsigned int altCRCs[10];				// up to 10 alternate CRCs

    ROMdata tempROMdata;						// only used for deleting the entire cmap


	unsigned int crc, size;
	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_TIMER, 1000, "Loading .dat file...");


	inFile = fopen(theApp.m_DATPath,"r");
	
	if (inFile == NULL)
	{
		AfxMessageBox("Failed to open dat file:"+theApp.m_DATPath+"\r\nGo to settings to browse to your .dat file.", MB_ICONEXCLAMATION, 0);
		goto exit;
	}
	
	// get the header info from the .dat file
	if (fileStuff.getDATHeader(inFile, header) == false)
	{
		AfxMessageBox("This .dat file is weird.  Couldn't locate header information.", MB_ICONEXCLAMATION, 0);
		goto exit;
	}
	
	AfxExtractSubString(theApp.m_datName, header, 1, '\n');
	AfxExtractSubString(theApp.m_datDescription, header, 2, '\n');
	AfxExtractSubString(theApp.m_datVersion, header, 3, '\n');
	AfxExtractSubString(theApp.m_datdate, header, 4, '\n');
	AfxExtractSubString(theApp.m_datAuthor, header, 5, '\n');
	AfxExtractSubString(theApp.m_datHomepage, header, 6, '\n');
	AfxExtractSubString(theApp.m_datComment, header, 7, '\n');


	theApp.m_datName.Replace("Name:","");
	theApp.m_datName.Trim();

	theApp.m_datDescription.Replace("Description:","");
	theApp.m_datDescription.Trim();

	theApp.m_datAuthor.Replace("Author:","");
	theApp.m_datAuthor.Trim();

	theApp.m_datHomepage.Replace("Homepage:","");
	theApp.m_datHomepage.Trim();

	theApp.m_datdate.Replace("Date:","");
	theApp.m_datdate.Trim();
	
	theApp.m_datVersion.Replace("Version:","");
	theApp.m_datVersion.Trim();

	theApp.m_datComment.Replace("Comment:","");
	theApp.m_datComment.Trim();

	fseek(inFile, 0, SEEK_SET);

	// delete the existing cmap data if we're reloading a file.
	// unfortunately, this doesn't work at all.  fucking cmaps.
	if (theApp.m_datfileCount != 0)
	{
		// delete the elements
		POSITION pos = theApp.m_ROMDATEntryName.GetStartPosition();
		while( pos != NULL )
		{
			CString    nKey;
			while (pos != NULL)
			{
				theApp.m_ROMDATEntryName.GetNextAssoc(pos, nKey,tempROMdata);
				theApp.m_ROMDATEntryName.RemoveKey(nKey);
			}

		}
		// RemoveAll deletes the keys
		theApp.m_ROMDATEntryName.RemoveAll();
		
		// delete the elements
		pos = theApp.m_ROMDATEntryCRC.GetStartPosition();
		while( pos != NULL )
		{
			CString    nKey;
			while (pos != NULL)
			{
				theApp.m_ROMDATEntryCRC.GetNextAssoc(pos, nKey,tempROMdata);
				theApp.m_ROMDATEntryCRC.RemoveKey(nKey);
			}

		}
		// RemoveAll deletes the keys
		theApp.m_ROMDATEntryCRC.RemoveAll();
		
		theApp.m_datZipList.clear();
		theApp.m_datZipList.empty();
	}

	// clear the counters
	theApp.m_datfileCount=0;
	theApp.m_datROMCount=0;

	// for every game{...} entry in the .dat file
	while ( (theApp.m_datfileCount < MAX_DATFILE) && (eof != -1) )
	{
		eof = fileStuff.getROMDesc(inFile, romDesc);
		pos = romDesc.Find("\"");
		pos++;
		pos2 = romDesc.Find("\"",pos);
		zipFilename = romDesc.Mid(pos, pos2-pos);	// get the name of the zip

		theApp.m_datZipList[theApp.m_datfileCount].filename= zipFilename;	// store the zip filename inside the structure inside the map.

		//TODO - shoudl really use tokenize for this.  get one line of data, between ( and ) and token it to parse the data.
		// file ( name 10ROGUE.EXE size 78344 date 1999\3\31 12:39 crc de6fc10c )

		romCount=0;		// number of roms in this zip
		while (zipFilename.GetLength() > 0)	// get the files (roms) inside this zip
		{
			//alternate = false;
			status = 0;
			tpos = romDesc.Find("file ( name ",pos);	// get the name (new .dat file version)
			if (tpos == -1) break;

			pos=tpos;
			pos+=11;
			pos2 = romDesc.Find(" size ",pos);
			if (pos2 == -1) break;
			name = romDesc.Mid(pos, pos2-pos);
			name.Trim();
			
			pos = romDesc.Find(" size ",pos2);		// get the size
			if (pos == -1) break;
			pos+=6;
			pos2 = romDesc.Find(" date ",pos);
			if (pos2 == -1) break;

			ssize = romDesc.Mid(pos, pos2-pos);
			sscanf(ssize,"%d",&size);

			// get the date
			pos = pos2+5;	
			pos2 = romDesc.Find(" crc ",pos2);
			datetime = romDesc.Mid(pos, pos2-pos);
			datetime.Trim();

			pos = pos2; //romDesc.Find(" crc ",pos2);		// get the crc
			if (pos == -1) break;
			pos+=5;
			pos2 = romDesc.Find(")",pos);
			if (pos2 == -1) break;
			scrc = romDesc.Mid(pos, pos2-pos);
			scrc.Trim();
/*			
			// multiple CRCs for this file?
			if (scrc.Find(" alt ") != -1)
			{
				alternate = true;			
				alts=0;
				scrc.Replace(" alt ","|");
				scrc.Append("|");
				while (scrc.Find("|") != -1)
				{
					CString tmp = scrc.Left(8);
					scrc.Replace(tmp, "");
					scrc.Trim();
					scrc.TrimLeft("|");
					sscanf(tmp,"%x",&crc);
					altCRCs[alts] = crc;
					alts++;
				}
				
				crc = altCRCs[0];	// for backwards compatibility, use the 1st CRC as the main one.
			}
			else
*/				
		
			sscanf(scrc,"%x",&crc);	
			date = String2Date(datetime);

			// examine .dat file entry for any skipped files.  we're going to take them out of the system altogether
			tmpfilename = name;
			ext = DC.extractExtension(tmpfilename);

			//if (DC.skipafile(tmpfilename, ext, crc, size) ==3)
			//	status = DATENTRY_STATUS_IGNORE;
			//{
			//	 name="";
			//	continue;
			//}

			
			

			// ok, we have a ROM to store in the database.
				// plug the above parsed values into our .dat entry

		rom2datmap(name, size, status, false, date, scrc, theApp.m_datfileCount, romCount);
		romCount++;	


		}	// while parsing rom entries (the big loop)

		// OK, we've stored all the ROMs from this zip into the cmap.
		// update the totals for the zip file
		if (zipFilename.GetLength() > 0)
		{
			theApp.m_datZipList[theApp.m_datfileCount].fileCount = romCount;	// store the # of ROMs the zip contains
			theApp.m_datZipList[theApp.m_datfileCount].status = 0;
			if (date == 0x2198bc00) // bit encoded date/time of 12/24/1996 - 23:32
				theApp.m_datZipList[theApp.m_datfileCount].status = TZIPPED;
			theApp.m_datfileCount++;	// global counter of # of items in the .dat file
		}
	} // while parsing the .dat file
exit:
	
	// close input file
	if (inFile != NULL)
	{
		fclose(inFile);	
		theApp.m_DATfileLoaded = true;
	}
	progDlg.DestroyWindow();
	theApp.m_datParsed = false;	// update the dat view if selected
	theApp.m_leftSideDATList.DeleteAllItems();
}

// add this rom into the main cmap based on CRC and filename
void CSettingsandTools::rom2datmap(CString name, unsigned int size, int status, bool found, unsigned int date, CString scrc, unsigned int ptr2zip, int romCount)
{
	ROMdata romInfo, tempROMdata;	// tempRomdata for lookups only
    LPCSTR ROMCRCKey;			// CRC is the key to storage
	CString tmpCrc;
	unsigned int crc;
	
	sscanf(scrc,"%x",&crc);				

	romInfo.fileName = name;
	romInfo.size = size;
	romInfo.status = status;
	romInfo.collision = false;
	romInfo.date = date;
	romInfo.crc = crc;
	romInfo.ptr2zipFileArray = ptr2zip;	// save a pointer (index) into the zip filename array

	// add a cmap entry for this file's CRC.  If it's a new CRC, it just gets added and then that cmap entry links back to the zipfile it belongs to.
	// if the CRC is already in the cmap, adust the CRC slightly to make a new "key" and try to store it again.  Repeat until we can find a home.
	// that means every file that is common among many games (gwbasic.exe for example) will try to get placed often.

	// theApp.m_ROMDATEntryCRC is the master CRC list of all the roms in the .dat file.  We use this to lookup a zip file we're scanning.
	// the stuff stored (ROMdata structure) in theApp.m_ROMDATEntryCRC include a pointer back to the .zip file this rom is found in the .dat file

	ROMCRCKey = scrc;
	tempROMdata.collision = false;	
	int collisionLimit = 0;
	while (collisionLimit < MAX_CRC_COLLISIONS)			// keep trying to locate a spot for this rom in the database, changing the key slightly til we find an empty spot.					
	{
		if (theApp.m_ROMDATEntryCRC.Lookup(ROMCRCKey, tempROMdata)) // before storing, check to see if there's someone home already.  get the structure into the temporary storage
		{	
			// bang!  we've got a collision
			if (!tempROMdata.collision)		// do know about this collision yet?  skip updating if so (to save time)
			{	
				tempROMdata.collision = true;						    // set the collision detected bit in the old one
				theApp.m_ROMDATEntryCRC.SetAt(ROMCRCKey, tempROMdata); // update the previous entry that we have a collision.
			}
			// make a new key and try again.
			tmpCrc=ROMCRCKey;
			theApp.makeNewKey(tmpCrc); // modify the key slightly so we: 1) know where it is, 2) make it unique to store somewhere else. (eg, gwbasic.exe_49381ba?1 -> gwbasic.exe_49381ba?2...)
			ROMCRCKey=tmpCrc;
			collisionLimit++;
		}
		else
			break;	// no collision, we can store this one here.
	}

	// ok, no collisions here, we can store this rom entry here.
//!	theApp.m_ROMDATEntryName.SetAt(ROMFilenameKey, romInfo );	 // store it the new ROM entry in a different location.

	// do I need to store this stuff?  each CRC has a pointer back to the zipfilename already.
	// romCount might be able to be replaced with the romsmap iterator.
	theApp.m_datZipList[theApp.m_datfileCount].ROMsMap[romCount].name = romInfo.fileName;
	theApp.m_datZipList[theApp.m_datfileCount].ROMsMap[romCount].crc = romInfo.crc;
	theApp.m_datZipList[theApp.m_datfileCount].ROMsMap[romCount].size = romInfo.size;
	theApp.m_datZipList[theApp.m_datfileCount].ROMsMap[romCount].date = romInfo.date;
	theApp.m_datZipList[theApp.m_datfileCount].ROMsMap[romCount].status = romInfo.status;
	//theApp.m_datZipList[theApp.m_datfileCount].status = romInfo.status;
	theApp.m_datROMCount++;

	// ok, no collisions here, we can store this rom's CRC entry here.
	if (collisionLimit != MAX_CRC_COLLISIONS)
		theApp.m_ROMDATEntryCRC.SetAt(ROMCRCKey, romInfo );	 // store it the new ROM entry in a different location.



	/*
	tmpfilename = name;
	tmpfilename.MakeLower();
	ROMFilenameKey = tmpfilename;
	while (1)			// keep trying to locate a spot for this rom in the database, changing the key slightly til we find an empty spot.					
	{
		if (theApp.m_ROMDATEntryName.Lookup(ROMFilenameKey, tempROMdata)) // before storing, check to see if there's someone home already.  get the structure into the temporary storage
		{	// bang!  we've got a collision
			tempROMdata.collision = true;						    // set the collision detected bit in the old one (it may already be set)
			theApp.m_ROMDATEntryName.SetAt(ROMFilenameKey, tempROMdata); // update the previous entry that we have a collision.
			theApp.makeNewKey(tmpfilename); // modify the key slightly so we: 1) know where it is, 2) make it unique to store somewhere else. (eg, gwbasic.exe_49381ba?1 -> gwbasic.exe_49381ba?2...)
			ROMFilenameKey = tmpfilename;			
		}
		else
			break;
	}
*/

}

// convert a date+time string to a 32bit value 
// example input: '2007\1\31 19:46'
unsigned int CSettingsandTools::String2Date(CString datetime)
{
	unsigned int y;                  /* year */
	unsigned int n;                  /* month */
	unsigned int d;                  /* day */
	unsigned int h;                  /* hour */
	unsigned int m;                  /* minute */
	unsigned int s;                  /* second */

	datetime.Replace("\\","/");

	sscanf( datetime, "%04d/%02d/%02d %02d:%02d:%02d", &y, &n, &d, &h, &m, &s );
	if (s > 59)
		s=0;

	if (y<1980)
	{
		y=1980;
		n=1;
		d=1;
		h=0;
		m=0;
		s=0;
	}
	/* Convert the date y/n/d and time h:m:s to a four byte DOS date and
	time (date in high two bytes, time in low two bytes allowing magnitude
	comparison). 
	y < 1980 ? dostime(1980, 1, 1, 0, 0, 0) :
	*/
	return (((unsigned long)y - 1980) << 25) | ((unsigned long)n << 21) | ((unsigned long)d << 16) | ((unsigned long)h << 11) | ((unsigned long)m << 5) | ((unsigned long)s >> 1);
}

void CSettingsandTools::OnBnClickedCancel()
{
	OnCancel();
}

void CSettingsandTools::OnBnClickedOk()
{
	CString txt;
	theApp.m_autoLoadDat = 0;
	if (((CButton*)GetDlgItem(IDC_DATAUTOLOAD))->GetCheck())
		theApp.m_autoLoadDat = 1;

	m_minScore4Rename.GetWindowText(txt);
	sscanf(txt, "%d", &theApp.m_minScoreForAutoRename);

//	theApp.m_ScanCRCFilename = ((CButton*)GetDlgItem(IDC_CRCFILENAME))->GetCheck();
	((CButton*)GetDlgItem(IDC_FQFLOGIN))->GetWindowText(theApp.m_mySitesDat);
	OnOK();
}

void CSettingsandTools::Add2DatFile()
{
	CString datEntry;
	int count=0;

	
	datEntry = "\ngame (\n\tname \"";
//	datEntry+=m_currentlyTaggedZipFile + "\"\n\tdescription \"";
	datEntry+=theApp.m_currentlyTaggedZipFile + "\"\n";

	while (  (theApp.m_zipDetailsList.GetItemText(count,FILENAMECOL) != "") && (theApp.m_zipDetailsList.GetItemText(count,COLORCOL) != COLOR_RED) )
	{
		datEntry +="\tfile ( name ";
		datEntry +=theApp.m_zipDetailsList.GetItemText(count,FILENAMECOL)+".";	// filename
		datEntry +=theApp.m_zipDetailsList.GetItemText(count,2);	// ext
		datEntry.TrimRight(".");	// remove dots from filenames without extensions
		datEntry+=" size ";
		datEntry +=theApp.m_zipDetailsList.GetItemText(count,3);	// size
		datEntry+=" date ";
		datEntry +=theApp.m_zipDetailsList.GetItemText(count,4);	// date
		datEntry+=" crc ";
		datEntry +=theApp.m_zipDetailsList.GetItemText(count,5);	// crc

		datEntry +=" )\n";
		count++;
	}
	datEntry +=")\n";

	// save it
	entry2File(datEntry);
}

void CSettingsandTools::entry2File(CString entry)
{
	FILE* inFile;
	// open the .dat file
	inFile = fopen(theApp.m_DATPath,"a");
	
	if (inFile == NULL)
		AfxMessageBox("Failed to open dat file:"+theApp.m_DATPath, MB_ICONEXCLAMATION, 0);
	else
	{
		fwrite(entry, sizeof( char ), entry.GetLength(), inFile );
		fclose(inFile);
	}
}

//todo - add a simple map here which keeps track of filenames, so we don't get a duplicate on the way in.
/*
//		theApp.m_datZipListit = theApp.m_datZipList.find(zipFilename);
//		if (theApp.m_datZipListit != theApp.m_datZipList.end())
//		{
//			//AfxMessageBox("Duplicate entry in .dat file detected! "+zipFilename, MB_ICONEXCLAMATION, 0);
//			duplicates+=zipFilename+"\r\n";
  //          zipFilename="";
//			duplicateEntries = true;
//		}
//		
//		else

*/
void CSettingsandTools::makeDATFile()
{
	CString filename;
	CString txt;
	unsigned int m_zipCount=0;
	unsigned int m_romCount=0;
	CProgressDlg progDlg;
	
	if (!m_cmdLine)
	{
		
		progDlg.Init(PROG_MODE_TIMER, 1000, "Scanning files, hang on...");
	}

	// now we have the path+filename we want to work with.
	// scan all the files in this selected folder.
	m_zipDir.ClearDirs();
	m_zipDir.ClearFiles();
	// look in the user folder, recursively is decided by the popup dialog
	m_zipDir.GetDirs(theApp.m_collectionPath, m_recursive);


   ///////////////////////////////////////////////////
   // get all files in the dirs we found above
   m_zipDir.GetFiles("*.zip");

   // sort them by name, ascending
   m_zipDir.SortFiles(CSADirRead::eSortAlpha, false);
   CSADirRead::SAFileVector &files = m_zipDir.Files();
   m_zipFiles = files.begin();

   // loop until we're out of files
   while ( m_zipFiles != files.end())
   {
		filename = (*m_zipFiles).m_sName;
		filename.Replace(theApp.m_collectionPath,"");
		
		// here we open the zip file, and get the contents out.
		if (!m_cmdLine)
			progDlg.UpdateText("Scanning files, hang on...",filename);
		m_romCount +=zip2dat(filename);
		m_zipFiles++;	// next file please
		m_zipCount++;
   }
	if (!m_cmdLine)
	{
		progDlg.DestroyWindow();
		txt.Format("\r\n.DAT contains %d zip files with %d files (roms)", m_zipCount, m_romCount);
		AfxMessageBox("Finished!\r\n"+theApp.m_DATPath+" created."+txt, MB_ICONINFORMATION, 0);
	}
}


void CSettingsandTools::OnBnClickedMakeadat()
{
	CFileStuff fileStuff;
	FILE* outFile;
	CString header;
	
	if (theApp.m_collectionPath.GetLength() == 0)
		OnBnClickedSetdoscollectionpathbtn();

	// browse to the output filename
	fileStuff.m_windowTitle = "Name of file to create...";
	if (fileStuff.UserBrowseSave(&theApp.m_DATPath, "dat files (*.dat)\0*.dat", "dat") != TRUE)
		return;

	// popup the .dat file information GUI
	
	CDATFileInfoDlg dlg;
	dlg.m_displayOnly = false;
	if (dlg.DoModal() == 2)	// cancel button hit?
		return;

	m_recursive = dlg.m_recursive;
	header = "DOSCenter (\r\n\tName:";
	header +=dlg.m_datTitleTxt;
	header +="\r\n\tDescription: ";
	header +=dlg.m_datDescTxt;
	header +="\r\n\tVersion: ";
	header +=dlg.m_datVerTxt;
	header +="\r\n\tDate: ";
	header +=dlg.m_dateTxt;
	header +="\r\n\tAuthor: ";
	header +=dlg.m_datAuthorTxt;
	header +="\r\n\tHomepage: ";
	header +=dlg.m_datWebTxt;
	header +="\r\n\tComment: ";
	header +=dlg.m_datCommentTxt;
	header +="\r\n)";
	
	// delete the .dat file if it exists, since the creator program uses append mode.
	// add a header to it.
	outFile = fopen(theApp.m_DATPath,"wb");
	if ( outFile != NULL )
		fwrite(header, sizeof( char ), header.GetLength(), outFile );
	
	if ( outFile != NULL )
	{
		fclose(outFile);
		outFile=NULL;
	}

	makeDATFile();

	CRegistry regMyReg( CREG_CREATE );  // create registry key if it doesn't exist.
	if ( regMyReg.Open("Software\\DOSCenter",HKEY_CURRENT_USER) ) 
		{
			// Now set the new values
			regMyReg["masterCollectionFolder"] = theApp.m_collectionPath;
			regMyReg.Close();
		}
//	((CButton*)GetDlgItem(IDC_ZIPFOLDERTXT))->SetWindowText("Zip folder: "+m_SourcePath);


}

int CSettingsandTools::zip2dat(CString zipfilename)
{
	CString datEntry;
	CString filename, ext, size, crc, date;
	WORD dosDate;
	WORD dosTime;
	CTime time;
	UZ_FileInfo info;

	// grab the zip and start displaying each file inside.
	m_uz.OpenZip(theApp.m_collectionPath+zipfilename);
	m_uz.GotoFirstFile();
	m_uz.GetFileInfo(info);
	//m_nFileCount = m_uz.GetFileCount();

	if (zipfilename.Find('\\') != -1) 
		zipfilename = zipfilename.Right(zipfilename.GetLength() - (zipfilename.ReverseFind('\\')) -1 );


	int g = tmpZipList[zipfilename];
	if (tmpZipList[zipfilename] == 1)
	{
		AfxMessageBox("Duplicate file detected and skipped!\r\n"+zipfilename, MB_ICONEXCLAMATION, 0);
		return 0;
	}
	else 
		tmpZipList[zipfilename] = 1;

	
	g = tmpZipList[zipfilename];

	datEntry = "\ngame (\n\tname \"";
	datEntry+=zipfilename + "\"\n";

	for (int i=0; i<m_uz.GetFileCount(); i++)	// gather all the info for each file in this zip and display it on the right hand window
	{
		filename = info.szFileName;
		ext = filename.Right(filename.GetLength() - filename.ReverseFind('.'));
		filename = filename.Left(filename.GetLength() - ext.GetLength());
		if (filename == "")
		{
			filename = ext;
			ext = "";
		}
		ext.TrimLeft(".");
		size.Format("%d",info.dwUncompressedSize);	
		crc.Format("%08x", info.dwCRC);
		dosDate = (WORD)(info.dwDosDate >> 16);
		dosTime = (WORD)info.dwDosDate & 0xffff;
		CTime time(dosDate, dosTime);
		date =time.Format( "%Y/%m/%d %H:%M:%S" );



		datEntry +="\tfile ( name ";
		datEntry +=info.szFileName; //theApp.m_zipDetailsList.GetItemText(count,FILENAMECOL)+".";	// filename
	//	datEntry +=theApp.m_zipDetailsList.GetItemText(count,2);	// ext
	//	datEntry.TrimRight(".");	// remove dots from filenames without extensions
		datEntry+=" size ";
		datEntry +=size;
		datEntry+=" date ";
		datEntry +=date;
		datEntry+=" crc ";
		datEntry +=crc;

		datEntry +=" )\n";


		m_uz.GotoNextFile();
		m_uz.GetFileInfo(info);
	}
	
	datEntry +=")\n";
	// huck it into the file
	entry2File(datEntry);
	return m_uz.GetFileCount();
}
/*
		filename = info.szFileName;
		ext = filename.Right(filename.GetLength() - filename.ReverseFind('.'));
		filename = filename.Left(filename.GetLength() - ext.GetLength());
		if (filename == "")
		{
			filename = ext;
			ext = "";
		}
		ext.TrimLeft(".");
		size.Format("%d",info.dwUncompressedSize);	
		crc.Format("%08x", info.dwCRC);
		dosDate = (WORD)(info.dwDosDate >> 16);
		dosTime = (WORD)info.dwDosDate & 0xffff;
		CTime time(dosDate, dosTime);
		date =time.Format( "%Y/%m/%d %H:%M:%S" );



		// color any known CRC files green.
		if (scanned != -1) // only color code a file if we've scanned and compared it to something
		{
			if ( (m_copyfileData[0].mymap[info.dwCRC].name != "") || (info.dwCRC == 0) )	// match?
			{
				m_copyfileData[0].mymap[info.dwCRC].found = true;		// set flag that we've matched this one.
				if ( !((CButton*)GetDlgItem(IDC_HIDEMATCHES))->GetCheck() )	// does the user want to see these items?
					theApp.m_zipDetailsList.AddItem(COLOR_GREEN,filename, ext, size, date, crc);
				
			}

			if ( (m_copyfileData[0].mymap[info.dwCRC].name == "") && (info.dwCRC != 0) )	// no match?
			{
				m_copyfileData[0].mymap[info.dwCRC].found = false;
				if ( !((CButton*)GetDlgItem(IDC_HIDEUNKNOWN))->GetCheck() )	// does the user want to see these items?
					theApp.m_zipDetailsList.AddItem(COLOR_BLACK,filename, ext, size, date, crc);
			}
		} 
		else // just 2x clicking any ole file-no text color coding here.
			theApp.m_zipDetailsList.AddItem(COLOR_BLACK,filename, ext, size, date, crc);
		
		
		m_uz.GotoNextFile();
		m_uz.GetFileInfo(info);
	}
	*/
void CSettingsandTools::OnBnClickedScratchpadbrowse()
{
	CFileStuff fileStuff;
	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(theApp.m_tmpWorkingFolder, "Set temporary working folder.") != TRUE)
		return;
	if (theApp.m_tmpWorkingFolder.Right(1) != "\\")
		theApp.m_tmpWorkingFolder+="\\";

	((CButton*)GetDlgItem(IDC_SCRATCHPATHTXT))->SetWindowText(theApp.m_tmpWorkingFolder);
	
}

void CSettingsandTools::OnBnClickedSetdoscollectionpathbtn()
{
	CFileStuff fileStuff;
	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(theApp.m_collectionPath, "Where's the master DOS collection?") != TRUE)
		return;
	if (theApp.m_collectionPath.Right(1) != "\\")
		theApp.m_collectionPath+="\\";

	((CButton*)GetDlgItem(IDC_DOSCOLLECTIONPATHTXT))->SetWindowText(theApp.m_collectionPath);
	
}

void CSettingsandTools::OnBnClickedScoringcfgbtn()
{
	CDOSCenterDlg meh;	
	CScoringSetupDlg dlg;
	dlg.DoModal();
	if (theApp.m_reloadIgnore)
		meh.populateIgnoreList();
}

void CSettingsandTools::OnBnClickedDosboxbrowse()
{
	CFileStuff fileStuff;
	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(theApp.m_dosboxPath, "Where is DOSBox?") != TRUE)
		return;
	if (theApp.m_dosboxPath.Right(1) != "\\")
		theApp.m_dosboxPath+="\\";
	
	((CButton*)GetDlgItem(IDC_DOBOXPATHTXT))->SetWindowText(theApp.m_dosboxPath);
}

void CSettingsandTools::OnBnClickedDatfileinfo()
{
	CDATFileInfoDlg dlg;
	dlg.m_displayOnly = true;
	dlg.DoModal();

}
void CSettingsandTools::OnBnClickedMissinglist()	// generate report button
{
	CDOSCenterDlg DC;
	((CButton*)GetDlgItem(IDC_FQFLOGIN))->GetWindowText(theApp.m_mySitesDat);
	DC.OnBnClickedMissinglist();
}
/*
void CSettingsandTools::OnBnClickedCrcscan()
{
	theApp.m_ScanCRCFilename = ((CButton*)GetDlgItem(IDC_CRCFILENAME))->GetCheck();
}

void CSettingsandTools::OnBnClickedCrcfilename()
{
	theApp.m_ScanCRCFilename = ((CButton*)GetDlgItem(IDC_CRCFILENAME))->GetCheck();
}
*/


void CSettingsandTools::OnBnClickedDetailedreports()
{
	((CButton*)GetDlgItem(IDC_PERFECTSTOO))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_PERFECTSTOO))->SetCheck(0);

	if ( ((CButton*)GetDlgItem(IDC_DETAILEDREPORTS))->GetCheck() )
	{	
		theApp.m_detailedReport = true;
		((CButton*)GetDlgItem(IDC_PERFECTSTOO))->EnableWindow(1);
		((CButton*)GetDlgItem(IDC_PERFECTSTOO))->SetCheck(theApp.m_reportPerfects);
	}
	else
		theApp.m_detailedReport = false;
}

void CSettingsandTools::OnBnClickedPerfectstoo()
{
	if ( ((CButton*)GetDlgItem(IDC_PERFECTSTOO))->GetCheck() )
		theApp.m_reportPerfects = true;
	else
		theApp.m_reportPerfects = false;

}

void CSettingsandTools::OnBnClickedFqfoutput()
{
	if ( ((CButton*)GetDlgItem(IDC_FQFOUTPUT))->GetCheck() )
	{
		theApp.m_makeFQFScript = true;
		((CButton*)GetDlgItem(IDC_FQFLOGIN))->EnableWindow(1);
		((CButton*)GetDlgItem(IDC_FQF_DL_PATH))->EnableWindow(1);
	}
	else
	{
		theApp.m_makeFQFScript = false;
		((CButton*)GetDlgItem(IDC_FQFLOGIN))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_FQF_DL_PATH))->EnableWindow(0);
	}


}

void CSettingsandTools::OnBnClickedFqfDlPath()
{
	CFileStuff fileStuff;
	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(theApp.m_fxpDlPath, "Download files to here.") != TRUE)
		return;
	if (theApp.m_fxpDlPath.Right(1) != "\\")
		theApp.m_fxpDlPath+="\\";

//	((CButton*)GetDlgItem(IDC_SCRATCHPATHTXT))->SetWindowText(theApp.m_fxpDlPath);
	
}

void CSettingsandTools::OnBnClickedHavemisslistcfg()
{
	CHaveMissDlg dlg;
	dlg.DoModal();
}
